/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/kyverno/kyverno/api/kyverno/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// ValidationFailureActionOverrideApplyConfiguration represents an declarative configuration of the ValidationFailureActionOverride type for use
// with apply.
type ValidationFailureActionOverrideApplyConfiguration struct {
	Action            *v1.ValidationFailureAction `json:"action,omitempty"`
	Namespaces        []string                    `json:"namespaces,omitempty"`
	NamespaceSelector *metav1.LabelSelector       `json:"namespaceSelector,omitempty"`
}

// ValidationFailureActionOverrideApplyConfiguration constructs an declarative configuration of the ValidationFailureActionOverride type for use with
// apply.
func ValidationFailureActionOverride() *ValidationFailureActionOverrideApplyConfiguration {
	return &ValidationFailureActionOverrideApplyConfiguration{}
}

// WithAction sets the Action field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Action field is set to the value of the last call.
func (b *ValidationFailureActionOverrideApplyConfiguration) WithAction(value v1.ValidationFailureAction) *ValidationFailureActionOverrideApplyConfiguration {
	b.Action = &value
	return b
}

// WithNamespaces adds the given value to the Namespaces field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Namespaces field.
func (b *ValidationFailureActionOverrideApplyConfiguration) WithNamespaces(values ...string) *ValidationFailureActionOverrideApplyConfiguration {
	for i := range values {
		b.Namespaces = append(b.Namespaces, values[i])
	}
	return b
}

// WithNamespaceSelector sets the NamespaceSelector field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the NamespaceSelector field is set to the value of the last call.
func (b *ValidationFailureActionOverrideApplyConfiguration) WithNamespaceSelector(value metav1.LabelSelector) *ValidationFailureActionOverrideApplyConfiguration {
	b.NamespaceSelector = &value
	return b
}
